#include <stdio.h>
#include <dos.h>
#include <conio.h>
#include <string.h>
#include "babpic.h"

void clearscreen(void);
int get_keyboard(void);
int getch(void);
int putch(int i);
int kbhit(void);
void set_cursor_pos(int col, int row);
void put_character(int code, int repeat);
int get_model_info(void);
void ShowEngine(void);
void ShowAxis(int Ax);
void HomeCursor(void);
void ClearEngine(void);
void ClearAxis(int Ax);
void WriteString(char *str);
void put_char_mvc(int code);
void PutCursor(int Axis, int Column);
void ShowMenu(void);
void CursorRight(void);
void CursorLeft(void);
void CursorUp(void);
void CursorDown(void);
void StoreChar(int c);
void RunEngine(void);
void RunAlong(void);
void AddAxis(int Ax);
void ShowAxes(void);
void WaitABit(void);
void InvertAxis(int Ax);
void InvertLogFlag(void);
long getticks(void);

int Axis,BellFlag,Column,isjag,LogFlag,SetFlag,Turns,xoffset,yoffset;
char Engine[9][32],TurnString[20];
FILE *fp;

/*
   Include option /Zr to enable pointer checking pragma usage
   for release phase.
*/

#pragma check_pointer(off)
long far * timeptr = (long far *) (0x0040006C);
#pragma check_pointer(on)

union REGS inregs, outregs;

main()
{
  int c,i,j;
  int oldattribute;

  SetFlag=1;
  BellFlag=1;
  LogFlag=0;
  isjag=get_model_info();
  if(isjag) {
    xoffset = 3;
    yoffset = 4;
  } else {
    xoffset = 18;
    yoffset = 7;
  }

  inregs.h.ah=8;
  inregs.h.bh=0;
  int86(0x10,&inregs,&outregs);
  oldattribute=outregs.h.ah;
  ClearEngine();
  ShowEngine();
  ShowMenu();
  PutCursor(Axis,Column);
  while ((c=get_keyboard())!=0xC4) {
    switch(c) {
      case 0xCB: CursorLeft(); break;
      case 0xCD: CursorRight(); break;
      case 0xD0: CursorDown(); break;
      case 0xC8: CursorUp(); break;
      case 0xBB: ClearEngine(); if(SetFlag) ShowAxes(); break;
      case 0xBC: ClearAxis(Axis); if(SetFlag) ShowAxis(Axis); break;
      case 0xBD: InvertAxis(Axis); break;
      case 0xBE: SetFlag=!SetFlag; if(!SetFlag) HomeCursor(); ShowMenu(); break;
      case 0xBF: RunEngine(); break;
      case 0xD8: RunAlong(); break;
      case 0xC1: InvertLogFlag(); ShowMenu(); break;
      case 0xC2: BellFlag=!BellFlag; ShowMenu(); break;
      case 48:
      case 49:
      case 50:
      case 51:
      case 52:
      case 53:
      case 54:
      case 55:
      case 56:
      case 57: StoreChar(c); break;
	break;
    }
    if(SetFlag) PutCursor(Axis,Column);
    else PutCursor(7,31);
  }
  if(LogFlag) fclose(fp);
  inregs.h.ah=6;
  inregs.h.al=0;
  inregs.h.bh=oldattribute; /* oldattribute; */
  inregs.h.ch=0;
  inregs.h.cl=0;
  inregs.h.dh=25;
  inregs.h.dl=80;
  int86(16,&inregs,&outregs);
  set_cursor_pos(0,0);
  put_character(32,2000);
  return(0);
}

void StoreChar(int c)
{
  if(!SetFlag) return;
  Engine[Axis][Column-1]=c;
  ShowAxis(Axis);
  CursorRight();
}

void ShowEngine(void)
{
  int Ax;
  int far *scnBuf;

  clearscreen();
  if(isjag) {
    set_cursor_pos(9,1);
    WriteString("HP 95 Difference Engine");
  } else {
    inregs.h.ah = 0xF;
    int86(0x10,&inregs,&outregs); /* Get Video Mode */
    if(outregs.h.al == 7)
      scnBuf = (int far *)0xB0000000; /* Mono */
    else
      scnBuf = (int far *)0xB8000000; /* color */
    _fmemmove(scnBuf,(int far *)eng2_screen,sizeof(eng2_screen));
  }
  ShowAxes();
  set_cursor_pos(xoffset+14,yoffset+13-4*isjag);
  WriteString("Turns: 0");
}

void ShowAxes(void)
{
  int Ax;

  for(Ax=0;Ax<8;Ax++) ShowAxis(Ax);
  Turns=0;
  set_cursor_pos(xoffset+21,yoffset+13-4*isjag);
  WriteString("0      ");
}

void WriteString(char *str)
{
  int i;

  i=0;
  while (str[i]!=0) put_char_mvc((int)str[i++]) ;
}

void HomeCursor()
{
  Axis=7; Column=31;
}

void ClearEngine()
{
  int Ax,i;

  if(SetFlag) {
    for(Ax=0;Ax<8;Ax++) ClearAxis(Ax);
    Turns=0;
    Axis=7; Column=31;
  }
  else i=putch('\a');
}

void ClearAxis(int Ax)
{
  int i;

  if(SetFlag) {
    for(i=0;i<31;i++) Engine[Ax][i]='0';
    Engine[Ax][31]=0;
  }
  else i=putch('\a');
}

void RunAlong(void)
{
   int c;

   if(SetFlag) {
     SetFlag=0;
     ShowMenu();
     return;
   }

  while(!kbhit()) {
    RunEngine();
    PutCursor(7,32);
    WaitABit();
  }
  if(!(c=getch())) c=getch();
}

void RunEngine(void)
{
   int Ax,i,j;

   Axis=7; Column=31;

   if(SetFlag) {
     SetFlag=0;
     ShowMenu();
     return;
   }

   for(Ax=1;Ax<8;Ax++) {
     set_cursor_pos(xoffset+34,yoffset+Ax);
     put_character('_',1);
     AddAxis(Ax);
     WaitABit();
     ShowAxis(Ax);
     set_cursor_pos(xoffset+34,yoffset+Ax);
     put_character(32,1);
   }
   if (LogFlag) {
     fputs(Engine[7],fp);
     fputc('\n',fp);
   }
   sprintf(TurnString,"%d     ",++Turns);
   set_cursor_pos(xoffset+21,yoffset+13-4*isjag);
   WriteString(TurnString);
}

void AddAxis(int Ax)
{
  int accumulator,carry,cursorpos,difference,i,sum;

  carry=0;
  for(i=30;i>=0;i--) {
    difference=Engine[Ax-1][i]-'0';
    accumulator=Engine[Ax][i]-'0';
    if(carry) {
      carry=0;
      if(++accumulator>9) {
	carry++;
	accumulator-=10;
      }
    }
    accumulator+=difference;
    if(accumulator>9) {
      carry++;
      accumulator-=10;
    }
    Engine[Ax][i]=accumulator+'0';
  }
  if((carry) && (BellFlag)) carry=putch('\a');
}

void InvertAxis(int Ax)
{
  int accumulator,carry,i;
  if(!SetFlag) { i=putch('\a'); return; }

  for(i=30;i>=0;i--) {
    accumulator=Engine[Ax][i]-'0';
    Engine[Ax][i]=9-accumulator+'0';
  }
  carry=0;
  for(i=30;i>=0;i--) {
    accumulator=Engine[Ax][i]-'0';
    if(carry) {
      carry=0;
      if(++accumulator>9) {
	carry++;
	accumulator-=10;
      }
    }
    accumulator+=(i==30);
    if(accumulator>9) {
      carry++;
      accumulator-=10;
    }
    Engine[Ax][i]=accumulator+'0';
  }
  ShowAxis(Ax);
}

void ShowAxis(int Ax)
{
  int i;

  set_cursor_pos(xoffset,yoffset+Ax);
  put_char_mvc("7654321T"[Ax]);
  put_character(':',1);
  for(i=0;i<31;i++) {
    set_cursor_pos(xoffset+i+3,yoffset+Ax);
    put_character(Engine[Ax][i],1);
  }
}

void CursorLeft(void)
{
  if(SetFlag) if(Column>1) Column=Column-1;
  PutCursor(Axis,Column);
}

void CursorRight(void)
{
  if(SetFlag) if(Column<31) Column++;
  PutCursor(Axis,Column);
}

void CursorUp(void)
{
  if(SetFlag) if(Axis>0) Axis--;
  PutCursor(Axis,Column);
}

void CursorDown(void)
{
  if(SetFlag) if(Axis<7) Axis++;
  PutCursor(Axis,Column);
}

int get_keyboard(void)
{
  int key;

  key=getch();
  if (key==0) key=getch() | 0x80;
  return(key);
}

void InvertLogFlag(void)
{
  LogFlag=!LogFlag;

  if(LogFlag) {
    if((fp=fopen("ENGINE.LOG","a"))==NULL) {
      LogFlag=0;
      if (isjag) set_cursor_pos(0,14);
      else set_cursor_pos(5,22);
      WriteString("Could not open file ENGINE.LOG!");
    } else {
      fputs(Engine[7],fp);
      fputc('\n',fp);
    }
  }
  else fclose(fp);
}

void PutCursor(int Axis, int Column)
{
  set_cursor_pos(xoffset+Column+2,yoffset+Axis);
}

void clearscreen(void)
{
  set_cursor_pos(0,0);
  if (!isjag) put_character(32,2000);
  else /* put_character(32,1280); */
  {
    inregs.h.ah = 6;
    inregs.h.al = 0;
    inregs.h.bh = 7;
    inregs.h.ch = 0;
    inregs.h.cl = 0;
    inregs.h.dh = 25;
    inregs.h.dl = 80;
    int86(16,&inregs,&outregs);
  }
}

void set_cursor_pos(int col, int row)
{
  inregs.h.ah = 0x02;
  inregs.h.bh = 0;
  inregs.h.dh = row;
  inregs.h.dl = col;

  int86(0x10, &inregs, &outregs);
}

void put_character(int code,int repeat)
{
  inregs.h.ah = 0x0A;
  inregs.h.al = code;
  inregs.h.bh = 0;
  inregs.x.cx = repeat;
  int86(0x10, &inregs, &outregs);
}

void put_char_mvc(int code)
{
  inregs.h.ah = 0x0E;
  inregs.h.al = code;
  inregs.h.bh = 0;
  int86(0x10, &inregs, &outregs);
}

#pragma check_pointer(off)
void WaitABit(void)
{
  long starttime,curtime,endtime;
  int running;

  starttime=getticks();
  endtime=starttime+2;
  running=1;
  while(running) {
    curtime=getticks();
    if(curtime<starttime) endtime=2;
    if(curtime>endtime) running=0;
  }
}

long getticks(void)
{
  long tmp;

  _disable();
  tmp = *timeptr;
  _enable();

  return tmp;
}
#pragma check_pointer(on)


int get_model_info(void)
{
  inregs.h.ah = 0x4D;
  inregs.h.al = 0xD4;
  int86(0x15, &inregs, &outregs);
  if (outregs.h.bh != 'H') return(0);
  if (outregs.h.bl != 'P') return(0);
  if (outregs.h.ch != 1) return(0);
  if (outregs.h.cl != 1) return(0);
  return(1);
}

void ShowMenu(void)
{
  if(isjag) {
    set_cursor_pos(0,15);
    WriteString("CLA CLR +-  SET  RUN    LOG  BELL   QUIT");
    if(SetFlag) {
      set_cursor_pos(15,15);
      put_character(42,1);
    }
    if(!SetFlag) {
      set_cursor_pos(20,15);
      put_character(42,1);
    }
    if(LogFlag) {
      set_cursor_pos(27,15);
      put_character(42,1);
    }
    if(BellFlag) {
      set_cursor_pos(33,15);
      put_character(42,1);
    }


	      /* 1234    9012    7890    5678    3456     */
  } else {
    set_cursor_pos(2,23);
    WriteString("F1:CLALL   F2:CLROW   F3:+-  F4:SET    F5:RUN   F7:LOG   F8:BELL    F10:QUIT");
    if(SetFlag) {
      set_cursor_pos(37,23);
      put_character(42,1);
    }
    if(!SetFlag) {
      set_cursor_pos(47,23);
      put_character(42,1);
    }
    if(LogFlag) {
      set_cursor_pos(56,23);
      put_character(42,1);
    }
    if(BellFlag) {
      set_cursor_pos(66,23);
      put_character(42,1);
    }

  }
}

