	TITLE Babbage Key Definitions
**miscdoc+*******************************************^******
************************************************************
**
** File:    BCKeyDefs.s
** Machine: Charlemagne
** Project: Babbage Engine
**
************************************************************
**+miscdoc**************************************************

INCLUDE ./BCRomId.h
INCLUDE ./BCExtDecl.h
INCLUDE ../../charle/Header.h

*****************************************************************************
*****************************************************************************
NULLNAME BCkeys
* ( #KeyCode #Plane --> KeyDef TRUE or FALSE )
* Main key assigment procedure.  Calls handlers for individual planes. 
::
  kpNoShift        #=casedrop     BCNoShift
  kpLeftShift      #=casedrop     BCLeftShift
  kpRightShift     #=casedrop     BCRghtShift
  DROP
  DROP ' DoBadKey TRUE
;
*****************************************************************************
*****************************************************************************
NULLNAME BCNoShift
* ( #keyCode --> KeyDef TRUE or FALSE )
* Unshifted key handler.
::
  kcOn             ?CaseRomptr@   BCOn
  kcNextRow        ?CaseRomptr@   BCNextRow
  kcUpArrow        ?CaseRomptr@   BCUp
  kcDownArrow      ?CaseRomptr@   BCDown
  kcLeftArrow      ?CaseRomptr@   BCLeft
  kcRightArrow     ?CaseRomptr@   BCRight
  kc0              ?CaseRomptr@   BC0
  kc1              ?CaseRomptr@   BC1
  kc2              ?CaseRomptr@   BC2
  kc3              ?CaseRomptr@   BC3
  kc4              ?CaseRomptr@   BC4
  kc5              ?CaseRomptr@   BC5
  kc6              ?CaseRomptr@   BC6
  kc7              ?CaseRomptr@   BC7
  kc8              ?CaseRomptr@   BC8
  kc9              ?CaseRomptr@   BC9
  kcNegate         ?CaseRomptr@   BCNegate
  kcLeftShift      #=casedrpfls 
  kcRightShift     #=casedrpfls
  DUP SEVEN        #< casedrpfls  ( *menu keys 1 to 6* )
  DROP ' DoBadKey TRUE
;
*****************************************************************************
*****************************************************************************
NULLNAME BCLeftShift
* ( #keyCode --> KeyDef TRUE or FALSE )
* Left shifted key handler.
::
  DUP SEVEN        #< casedrpfls  ( *menu keys 1 to 6* )
  kcNextRow        ?CaseRomptr@   BCPrevRow
  kcLeftArrow      ?CaseRomptr@   BCPgLeft
  kcRightArrow     ?CaseRomptr@   BCPgRight
  kcMathMenu       ?CaseRomptr@   BCDoPrint
  kcLeftShift      #=casedrpfls 
  kcRightShift     #=casedrpfls
  DROP ' DoBadKey TRUE
 ;
*****************************************************************************
*****************************************************************************
NULLNAME BCRghtShift
* ( #keyCode --> KeyDef TRUE or FALSE )
* Browser right shifted key handler.
::
  kcLeftArrow      ?CaseRomptr@   BCFarLeft
  kcRightArrow     ?CaseRomptr@   BCFarRight
  kcLeftShift      #=casedrpfls 
  kcRightShift     #=casedrpfls
  kcOn		   #=casedrpfls
  DROP ' DoBadKey TRUE
;
*****************************************************************************
*****************************************************************************
NULLNAME BCOn
::
  TakeOver TRUE ' LAM Done STO
;
*****************************************************************************
*****************************************************************************
NULLNAME BCTogSet
::
  LAM Set DUP IT
    ::
      BCCurClr
      EIGHT ' LAM Row STO
      THIRTYONE ' LAM Col STO
    ;
  NOT ' LAM Set STO
  BCShowCur
  DispMenu.1
;
*****************************************************************************
*****************************************************************************
NULLNAME BCSoftKeys
{
  { "CLALL" :: TakeOver LAM Set NOTcase DoBadKey BCClear ; }
  { "CLRW" { :: TakeOver BCClrRow ; :: TakeOver BCClrRow9 ; } }
  {
    :: TakeOver "SET" LAM Set Box/StdLabel ;
    :: TakeOver BCTogSet ;
  }
  {
    :: TakeOver "RUN" LAM Set NOT Box/StdLabel ;
    { :: TakeOver BCRun ; :: TakeOver BCRunC ; }
  }
  {
    :: TakeOver LAM Turns UNCOERCE EDITDECOMP$ MakeStdLabel ;
    :: TakeOver ZERO ' LAM Turns STO DispMenu.1 ;
  }
  { "QUIT" :: TakeOver TRUE ' LAM Done STO ; }
*
* 2nd page
*
  { "PRINT" :: TakeOver BCDoPrint ; }
  {
    :: TakeOver "TRC" LAM Trc Box/StdLabel ;
    :: TakeOver LAM Trc NOT ' LAM Trc STO DispMenu.1 ;
  }
  {
    :: TakeOver "FULL" LAM Full Box/StdLabel ;
    :: TakeOver LAM Full NOT ' LAM Full STO DispMenu.1 ;
  }
  {
    :: TakeOver "TOT" LAM Full NOT Box/StdLabel ;
    :: TakeOver LAM Full NOT ' LAM Full STO DispMenu.1 ;
  }
  {
    :: TakeOver "BELL" FIFTYSIX TestSysFlag NOT Box/StdLabel ;
    :: TakeOver FIFTYSIX DUP SysITE ClrSysFlag SetSysFlag DispMenu.1 ;
  }
  { "QUIT" :: TakeOver TRUE ' LAM Done STO ; }
}
*****************************************************************************
*****************************************************************************
NULLNAME BCNextRow
* Process NXT key if > 6 softkeys in menu
::
  TakeOver
  BCSoftKeys LENCOMP SEVEN #<case DoBadKey
  SIX SetSomeRow DispMenu
;
*****************************************************************************
*****************************************************************************
NULLNAME BCPrevRow
* Process PREV key if > 6 softkeys in menu
::
  TakeOver
  BCSoftKeys LENCOMP SEVEN #<case DoBadKey
  DoPrevRow DispMenu
;
*****************************************************************************
*****************************************************************************
NULLNAME BCClrRow9
::
  LAM Set NOTcase DoBadKey
  "9999999999999999999999999999999" TOTEMPOB
  BCAxisList
  LAM Row NTHCOMPDROP STO
  BCCurClr ( *Redisplays row w/o cursor* )
  BCShowCur
;
*****************************************************************************
*****************************************************************************
NULLNAME BCNegate
::
  TakeOver
  LAM Set NOTcase DoBadKey
  "0000000000000000000000000000001"
  BCAxisList LAM Row NTHCOMPDROP EVAL
CODE
	GOSBVL	=SAVPTR
	A=DAT1	A
	D1=A
	D1=D1+	10		D1 -> 1st chr
	LC(5)	30
	D=C	A
	LC(2)	"0"
	B=C	A
	LA(1)	9
NTop
	C=DAT1	B		Read chr
	C=C-B	B		Subtract ASCII offset
	C=A-C	P		Subtract 9-c
	C=C+B	B		Add back in ASCII offset
	DAT1=C	B
	D1=D1+	2		Point to next chr
	D=D-1	A		More chrs?
	GONC	NTop
	GOVLNG	=GETPTRLOOP
ENDCODE
  BCAddit 3DROP BCCurClr BCShowCur
;
*****************************************************************************
*****************************************************************************
NULLNAME BCClrRow
::
  LAM Set NOTcase DoBadKey
  "0000000000000000000000000000000" TOTEMPOB
NULLNAME BCAxisList
  { LAM Axis7 LAM Axis6 LAM Axis5 LAM Axis4 LAM Axis3 LAM Axis2 LAM Axis1 LAM AxisT }
  LAM Row NTHCOMPDROP STO
  BCCurClr ( *Redisplays row w/o cursor* )
  BCShowCur
;
*****************************************************************************
*****************************************************************************
NULLNAME BCFarLeft
::
  TakeOver LAM Set NOTcase DoBadKey
  LAM Col ONE #= case DoBadKey
  BCCurClr ONE ' LAM Col STO BCShowCur
;
*****************************************************************************
*****************************************************************************
NULLNAME BCFarRight
::
  TakeOver LAM Set NOTcase DoBadKey
  LAM Col THIRTYONE #= case DoBadKey
  BCCurClr THIRTYONE ' LAM Col STO BCShowCur
;
*****************************************************************************
*****************************************************************************
NULLNAME BCLeft
::
  TakeOver LAM Set NOTcase DoBadKey
  LAM Col DUP ONE #> NOTcasedrop DoBadKey
  BCCurClr #1- ' LAM Col STO BCShowCur
;
*****************************************************************************
*****************************************************************************
NULLNAME BCPgLeft
::
  TakeOver LAM Set NOTcase DoBadKey
  LAM Col DUP ONE #> NOTcasedrop DoBadKey
  BCCurClr DUP#1- EIGHT #MIN #-
  ' LAM Col STO BCShowCur
;
*****************************************************************************
*****************************************************************************
NULLNAME BCPgRight
::
  TakeOver LAM Set NOTcase DoBadKey
  LAM Col DUP THIRTYONE #= casedrop DoBadKey
  BCCurClr DUP THIRTYONE SWAP#- EIGHT #MIN #+
  ' LAM Col STO BCShowCur
;
*****************************************************************************
*****************************************************************************
NULLNAME BCRight
::
  TakeOver LAM Set NOTcase DoBadKey
  LAM Col DUP THIRTYONE #= casedrop DoBadKey
  BCCurClr #1+ ' LAM Col STO BCShowCur
;
*****************************************************************************
*****************************************************************************
NULLNAME BCUp
::
  TakeOver LAM Set NOTcase DoBadKey 
  LAM Row DUP #1= casedrop DoBadKey
  BCCurClr #1- ' LAM Row STO BCShowCur
;
*****************************************************************************
*****************************************************************************
NULLNAME BCDown
::
  TakeOver LAM Set NOTcase DoBadKey
  LAM Row DUP EIGHT #= casedrop DoBadKey
  BCCurClr #1+ ' LAM Row STO BCShowCur
;
*****************************************************************************
*****************************************************************************
NULLNAME BC0
::
  TakeOver BCRowPrep FORTYEIGHT BCStuffNum
;
*****************************************************************************
*****************************************************************************
NULLNAME BC1
::
  TakeOver BCRowPrep FORTYNINE BCStuffNum
;
*****************************************************************************
*****************************************************************************
NULLNAME BC2
::
  TakeOver BCRowPrep FIFTY BCStuffNum
;
*****************************************************************************
*****************************************************************************
NULLNAME BC3
::
  TakeOver BCRowPrep FIFTYONE BCStuffNum
;
*****************************************************************************
*****************************************************************************
NULLNAME BC4
::
  TakeOver BCRowPrep FIFTYTWO BCStuffNum
;
*****************************************************************************
*****************************************************************************
NULLNAME BC5
::
  TakeOver BCRowPrep FIFTYTHREE BCStuffNum
;
*****************************************************************************
*****************************************************************************
NULLNAME BC6
::
  TakeOver BCRowPrep FIFTYFOUR BCStuffNum
;
*****************************************************************************
*****************************************************************************
NULLNAME BC7
::
  TakeOver BCRowPrep FIFTYFIVE BCStuffNum
;
*****************************************************************************
*****************************************************************************
NULLNAME BC8
::
  TakeOver BCRowPrep FIFTYSIX BCStuffNum
;
*****************************************************************************
*****************************************************************************
NULLNAME BC9
::
  TakeOver BCRowPrep FIFTYSEVEN BCStuffNum
;
*****************************************************************************
*****************************************************************************
NULLNAME BCRowPrep
* ( --> $ #chr )
::
  LAM Set NOTcase :: DoBadKey RDROP ;
  BCAxisList LAM Row NTHCOMPDROP EVAL LAM Col
;
*****************************************************************************
*****************************************************************************
NULLNAME BCStuffNum
* ( $ #col #val --> )
::
CODE
	GOSBVL	=POP2#
	R0=A			R0 = character position
	R1=C			R1 = character value
	GOSBVL	=SAVPTR
	A=DAT1	A		A -> string
	A=A+CON	A,8		A -> 1st char
	C=R0			C = char pos
	A=A+C	A
	A=A+C	A
	D1=A
	C=R1
	DAT1=C	B
	GOVLNG	=GETPTRLOOP
ENDCODE
  DROP BCCurClr
  LAM Col DUP THIRTYONE #= casedrop BCShowCur
  #1+ ' LAM Col STO BCShowCur
;
*****************************************************************************
*****************************************************************************
