	TITLE Babbage Engine %I%
**miscdoc+*******************************************^******
************************************************************
**
** File:    %M% Version %I%, %G%
** Machine: Charlemagne
**
************************************************************
**+miscdoc**************************************************

INCLUDE ./BCRomId.h
INCLUDE ./BCExtDecl.h
INCLUDE ../../charle/Header.h

** Macro definitions:

DEFINE BCLeftPos	SEVEN


*****************************************************************************
*****************************************************************************
NULLNAME BCDoVer
::
  RECLAIMDISP
  THIRTYSEVEN ZERO  "The HP 48" $>GROB XYGROBDISP
  FIFTEEN TEN "Difference Engine" $>GROB XYGROBDISP
  TEN TWENTYTWO "A TRIBUTE TO CHARLES BABBAGE" $>grob XYGROBDISP
  FORTYEIGHT THIRTYONE "Version A" $>grob XYGROBDISP
  FOUR FORTYONE "COPYRIGHT" $>grob XYGROBDISP
  FORTY THIRTYNINE "\A9" $>BIGGROB XYGROBDISP
  FORTYEIGHT FORTYONE "James Donnelly 1992" $>grob XYGROBDISP
  TWENTYEIGHT FIFTY "ALL RIGHTS RESERVED" $>grob XYGROBDISP
  SetDAsTemp
;
*****************************************************************************
************************************************************
**
** Name: BCMain - Display the Engine; start POL
**
** Author: Jim Donnelly
**
** Date Written: 9/92
**
************************************************************

NULLNAME BCMain
::
  RECLAIMDISP TURNMENUOFF DOCLLCD
  ZEROZERO BCEngine1 XYGROBDISP
  VERYSLOW
  VERYSLOW
  VERYSLOW
  VERYSLOW
  VERYSLOW
  DOCLLCD
  POLSaveUI
  ERRSET ::

*
* Disable the clock display and unlock alpha
*

  ClrDA1IsStat
  UnLockAlpha

*
* Establish local variables
*

  FIFTYSIX TestSysFlag	( Beepflag )
  FalseFalse		( Done Trc )
  ZERO			( Turns )
  TrueTrue		( Set Full )
  ZEROZERO		( Col,Row )
  ZEROZERO
  ZEROZERO
  ZEROZERO
  ZEROZERO
  {
    LAM Bf
    LAM Done
    LAM Trc
    LAM Turns
    LAM Set
    LAM Full
    LAM Col
    LAM Row
    LAM Axis7
    LAM Axis6
    LAM Axis5
    LAM Axis4
    LAM Axis3
    LAM Axis2
    LAM Axis1
    LAM AxisT
  }
  BIND

*
* Fire up parameterized outer loop
*

  BCClear			( *Clear & display the Engine* )
  ZERO ZERO "7:" $>grob XYGROBDISP
  ZERO SEVEN "6:" $>grob XYGROBDISP
  ZERO FOURTEEN "5:" $>grob XYGROBDISP
  ZERO TWENTYONE "4:" $>grob XYGROBDISP
  ZERO TWENTYEIGHT "3:" $>grob XYGROBDISP
  ZERO THIRTYFIVE "2:" $>grob XYGROBDISP
  ZERO FORTYTWO "1:" $>grob XYGROBDISP
  ZERO FORTYNINE "T:" $>grob XYGROBDISP
  ClrDAsOK			( *We'll need the menu* )
  RESOROMP BCDisplay		( AppDisplay )
  RESOROMP BCkeys		( AppDisplay AppKeys )
  TrueTrue			( AppDisplay AppKeys NonAppKeyOK? DoStdKeys? )
  BCSoftKeys			( AppDisplay AppKeys NonAppKeyOK? DoStdKeys? AppMenu )
  ONEFALSE'			( ... #AppMenuRow SuspendOK? )
  LAM Done			( ... ExitCond )
  'ERRJMP

  ( AppDisplay AppKeys NonAppKeyOK? DoStdKeys? AppMenu #AppMenuRow SuspendOK? ExitCond AppError )

  POLSetUI                        ( *Set up new user interface* )
  POLKeyUI                        ( *Process keys until CLExtFlg is TRUE* )
*
* Cleanup.
*
  FIFTYSIX LAM Bf ITE SetSysFlag ClrSysFlag
  ClrDAsOK                        ( *display needs updating* )
  ; ERRTRAP POLResUI&Err
  POLRestoreUI
;

************************************************************
************************************************************
NULLNAME BCClear
::
  "0000000000000000000000000000000" TOTEMPOB
  DUP TOTEMPOB ' LAM Axis1 STO
  DUP TOTEMPOB ' LAM Axis2 STO
  DUP TOTEMPOB ' LAM Axis3 STO
  DUP TOTEMPOB ' LAM Axis4 STO
  DUP TOTEMPOB ' LAM Axis5 STO
  DUP TOTEMPOB ' LAM Axis6 STO
  DUP TOTEMPOB ' LAM Axis7 STO
               ' LAM AxisT STO
  BCShow
  EIGHT ' LAM Row STO
  THIRTYONE ' LAM Col STO
  BCShowCur
  ZERO ' LAM Turns STO DispMenu.1
;
************************************************************
************************************************************
NULLNAME BCShow
::
NULLNAME BCShowAxis7
  :: BCLeftPos  ZERO LAM Axis7 $>grob XYGROBDISP ;
NULLNAME BCShowAxis6
  :: BCLeftPos  SEVEN LAM Axis6 $>grob XYGROBDISP ;
NULLNAME BCShowAxis5
  :: BCLeftPos FOURTEEN LAM Axis5 $>grob XYGROBDISP ;
NULLNAME BCShowAxis4
  :: BCLeftPos TWENTYONE LAM Axis4 $>grob XYGROBDISP ;
NULLNAME BCShowAxis3
  :: BCLeftPos TWENTYEIGHT LAM Axis3 $>grob XYGROBDISP ;
NULLNAME BCShowAxis2
  :: BCLeftPos THIRTYFIVE LAM Axis2 $>grob XYGROBDISP ;
NULLNAME BCShowAxis1
  :: BCLeftPos FORTYTWO LAM Axis1 $>grob XYGROBDISP ;
NULLNAME BCShowAxisT
  :: BCLeftPos FORTYNINE LAM AxisT $>grob XYGROBDISP ;
;
************************************************************
************************************************************
NULLNAME BCDisplay
::
  DA3OK? ?SEMI			( *Exit if the menu's OK* )
  DispMenu			( *Display the menu* )
  SetDA3ValidF ClrDA3Bad	( *Assert valid, clear "bad"* )
;
************************************************************
************************************************************
NULLNAME BCShowCur
::
  LAM Set NOT?SEMI		( *Exit if not showing cursor* )
  LAM Col			( #chr )
  #1- FOUR #* BCLeftPos #+	( xpos )
  LAM Row SEVEN #* #2- 		( xpos ypos )
  OVER #2+ OVER LINEON		(  )
;
************************************************************
************************************************************
NULLNAME BCCurClr
::
  { BCShowAxis7 BCShowAxis6 BCShowAxis5 BCShowAxis4 BCShowAxis3
    BCShowAxis2 BCShowAxis1 BCShowAxisT }
  LAM Row NTHCOMPDROP EVAL
;
************************************************************
************************************************************
NULLNAME BCRunC
::
  LAM Set case BCTogSet
  FLUSHKEYS
  BEGIN
    BCRunIt
    ATTN? KEYINBUFFER? OR NOT
  WHILE
    VERYSLOW
  REPEAT
  FLUSHKEYS ATTNFLGCLR
;
************************************************************
************************************************************
NULLNAME BCRun
::
  LAM Set case BCTogSet
NULLNAME BCRunIt
 ::
  LAM Turns #1+ ' LAM Turns STO

  LAM Axis7
  BINT_130d SEVEN BINT_130d TWELVE LINEON
  LAM Axis6 BCAddem BCShowAxis6
  BINT_130d SEVEN BINT_130d TWELVE LINEOFF

  BINT_130d FOURTEEN BINT_130d NINETEEN LINEON
  LAM Axis5 BCAddem BCShowAxis5
  BINT_130d FOURTEEN BINT_130d NINETEEN LINEOFF

  BINT_130d TWENTYONE BINT_130d TWENTYSIX LINEON
  LAM Axis4 BCAddem BCShowAxis4
  BINT_130d TWENTYONE BINT_130d TWENTYSIX LINEOFF

  BINT_130d TWENTYEIGHT BINT_130d THIRTYTHREE LINEON
  LAM Axis3 BCAddem BCShowAxis3
  BINT_130d TWENTYEIGHT BINT_130d THIRTYTHREE LINEOFF

  BINT_130d THIRTYFIVE BINT_130d FORTYTHREE LINEON
  LAM Axis2 BCAddem BCShowAxis2
  BINT_130d THIRTYFIVE BINT_130d FORTYTHREE LINEOFF

  BINT_130d FORTYTWO BINT_130d FORTYSEVEN LINEON
  LAM Axis1 BCAddem BCShowAxis1
  BINT_130d FORTYTWO BINT_130d FORTYSEVEN LINEOFF

  BINT_130d FORTYNINE BINT_130d FIFTYFOUR LINEON
  LAM AxisT BCAddem DROP BCShowAxisT
  BINT_130d FORTYNINE BINT_130d FIFTYFOUR LINEOFF

  DispMenu.1
  LAM Trc NOT?SEMI
  BCDoPrint
 ;
;
************************************************************
************************************************************
NULLNAME BCPrintMsg
::
  35 20 35 35 LINEOFF 36 20 BCPrinting XYGROBDISP
;
************************************************************
************************************************************
NULLNAME BCDoPrint
::
  TakeOver
  THIRTYFIVE TWENTY HARDBUFF 35 20 99 36 SUBGROB
  SetEcma94
  "Turns: "
  LAM Turns UNCOERCE
  EDITDECOMP$ &$ PRINT DOCR
  THIRTYFOUR SysITE
    :: ( *Serial* )
      BCPrintMsg
      LAM Full IT
        ::
	  "7: " LAM Axis7 &$ PRINT
	  "6: " LAM Axis6 &$ PRINT
	  "5: " LAM Axis5 &$ PRINT
	  "4: " LAM Axis4 &$ PRINT
	  "3: " LAM Axis3 &$ PRINT
	  "2: " LAM Axis2 &$ PRINT
	  "1: " LAM Axis1 &$ PRINT
        ;
      "T: " LAM AxisT &$ PRINT
      "----------------------------------"
    ;
    :: ( *IR* )
      HARDBUFF ZERO LAM Full ITE
        ZERO
        FORTYNINE
      BINT_131d
      FIFTYSIX
      SUBGROB
      BCPrintMsg
      PrintGrob DROP
      "----------------------"
    ;
  DOCR PRINT DOCR
  XYGROBDISP
;
************************************************************
************************************************************
NULLNAME BCAddem
* ( ColA ColB --> ColB' )
::
NULLNAME BCAddit
CODE
	GOSBVL	=SAVPTR
	AD1EX
	D1=A
	D0=A		D0 -> ColB pointer
	A=DAT0	A	A  -> ColB
	LC(5)	10+60	Prologue + 30 chars
	A=A+C	A	Add offset
	D0=A		D0 -> ColB 31st char
	D1=D1+	5
	A=DAT1	A
	A=A+C	A	Add offset
	D1=A		D1 -> ColA 31st char
	A=0	W
	B=0	W
	C=0	W
	D=0	W
	LC(5)	30
	D=C	A	Counter: D=digit #
	LC(5)	48
	B=C	A	Offset:  B="0"-48
Top
	A=DAT1	B	Read ColA digit
	A=A-B	B	Subtract to get BCD digit
	C=DAT0	B	Read ColB digit
	C=C-B	B	Subtract to get BCD digit
	SETDEC
	?B=0	S	Was there a carry to add in?
	GOYES	DoIt	No, just do it
	B=0	S	Clear previous digit carry info
	C=C+1	P	Add in the carry
	GONC	DoIt	Did that trigger a carry?
	B=B+1	S	Yes, trigger carry to next digit
DoIt
	C=A+C	P	Add Em!
	GONC	ToNxt
	B=B+1	S
ToNxt
	SETHEX		C = New ColB BCD digit value
	C=C+B	B	C = ASCII digit
	DAT0=C	B	Write new digit
	D1=D1-	2	Back to ...
	D0=D0-	2	... previous digits
	D=D-1	A
	GONC	Top
	?B=0	S
	GOYES	Out
Out
	GOVLNG	=GPPushT/FLp
ENDCODE
  ?SKIP :: % 880 % .1 DOBEEP ;
  SWAPDROP
;
************************************************************
************************************************************
NULLNAME BCPrinting
ASSEMBLE
        CON(5)  =DOGROB
        REL(5)  eprinting
        CON(5)  15
        CON(5)  62
        NIBHEX  ff
        NIBHEX  ff
        NIBHEX  ff
        NIBHEX  ff
        NIBHEX  ff
        NIBHEX  ff
        NIBHEX  ff
        NIBHEX  f0
        NIBHEX  10
        NIBHEX  00
        NIBHEX  00
        NIBHEX  00
        NIBHEX  00
        NIBHEX  00
        NIBHEX  00
        NIBHEX  81
        NIBHEX  10
        NIBHEX  00
        NIBHEX  00
        NIBHEX  00
        NIBHEX  00
        NIBHEX  00
        NIBHEX  00
        NIBHEX  81
        NIBHEX  97
        NIBHEX  00
        NIBHEX  20
        NIBHEX  01
        NIBHEX  40
        NIBHEX  00
        NIBHEX  00
        NIBHEX  81
        NIBHEX  98
        NIBHEX  00
        NIBHEX  00
        NIBHEX  01
        NIBHEX  00
        NIBHEX  00
        NIBHEX  00
        NIBHEX  81
        NIBHEX  98
        NIBHEX  a3
        NIBHEX  3e
        NIBHEX  93
        NIBHEX  6c
        NIBHEX  3c
        NIBHEX  10
        NIBHEX  81
        NIBHEX  97
        NIBHEX  60
        NIBHEX  22
        NIBHEX  21
        NIBHEX  44
        NIBHEX  42
        NIBHEX  20
        NIBHEX  81
        NIBHEX  90
        NIBHEX  20
        NIBHEX  22
        NIBHEX  21
        NIBHEX  44
        NIBHEX  42
        NIBHEX  20
        NIBHEX  81
        NIBHEX  90
        NIBHEX  20
        NIBHEX  22
        NIBHEX  25
        NIBHEX  44
        NIBHEX  4c
        NIBHEX  30
        NIBHEX  81
        NIBHEX  90
        NIBHEX  20
        NIBHEX  72
        NIBHEX  22
        NIBHEX  e4
        NIBHEX  40
        NIBHEX  25
        NIBHEX  91
        NIBHEX  10
        NIBHEX  00
        NIBHEX  00
        NIBHEX  00
        NIBHEX  00
        NIBHEX  0c
        NIBHEX  10
        NIBHEX  81
        NIBHEX  10
        NIBHEX  00
        NIBHEX  00
        NIBHEX  00
        NIBHEX  00
        NIBHEX  00
        NIBHEX  00
        NIBHEX  81
        NIBHEX  10
        NIBHEX  00
        NIBHEX  00
        NIBHEX  00
        NIBHEX  00
        NIBHEX  00
        NIBHEX  00
        NIBHEX  81
        NIBHEX  ff
        NIBHEX  ff
        NIBHEX  ff
        NIBHEX  ff
        NIBHEX  ff
        NIBHEX  ff
        NIBHEX  ff
        NIBHEX  f1
        NIBHEX  ef
        NIBHEX  ff
        NIBHEX  ff
        NIBHEX  ff
        NIBHEX  ff
        NIBHEX  ff
        NIBHEX  ff
        NIBHEX  f1
eprinting
RPL
************************************************************
************************************************************


